Index: branches/HM-10.0-dev-SHM/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/App/TAppEncoder/TAppEncTop.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/App/TAppEncoder/TAppEncTop.cpp	(revision 54)
@@ -428,5 +964,5 @@
     // call encoding function for one frame
     m_cTEncTop.encode( bEos, flush ? 0 : pcPicYuvOrg, m_cListPicYuvRec, outputAccessUnits, iNumEncoded );
-    
+
     // write bistream to file if necessary
     if ( iNumEncoded > 0 )
@@ -443,16 +979,17 @@
   delete pcPicYuvOrg;
   pcPicYuvOrg = NULL;
-  
+
   // delete used buffers in encoder class
   m_cTEncTop.deletePicBuffer();
-  
+
   // delete buffers & classes
   xDeleteBuffer();
   xDestroyLib();
-  
+
   printRateSummary();
 
   return;
 }
+#endif
 
 // ====================================================================================================================
@@ -461,13 +998,92 @@
 
 /**
- - application has picture buffer list with size of GOP
- - picture buffer list acts as ring buffer
- - end of the list has the latest picture
- .
- */
+- application has picture buffer list with size of GOP
+- picture buffer list acts as ring buffer
+- end of the list has the latest picture
+.
+*/
+#if SVC_EXTENSION
+Void TAppEncTop::xGetBuffer( TComPicYuv*& rpcPicYuvRec, UInt layer)
+{
+  assert( m_iGOPSize > 0 );
+
+  // org. buffer
+  if ( m_acListPicYuvRec[layer].size() == (UInt)m_iGOPSize )
+  {
+    rpcPicYuvRec = m_acListPicYuvRec[layer].popFront();
+
+  }
+  else
+  {
+    rpcPicYuvRec = new TComPicYuv;
+
+#if SVC_UPSAMPLING
+    rpcPicYuvRec->create( m_acLayerCfg[layer].getSourceWidth(), m_acLayerCfg[layer].getSourceHeight(), m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth, NULL );
+#else
+    rpcPicYuvRec->create( m_acLayerCfg[layer].getSourceWidth(), m_acLayerCfg[layer].getSourceHeight(), m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
+#endif
+
+  }
+  m_acListPicYuvRec[layer].pushBack( rpcPicYuvRec );
+}
+
+Void TAppEncTop::xDeleteBuffer( )
+{
+  for(UInt layer=0; layer<m_numLayers; layer++)
+  {
+    TComList<TComPicYuv*>::iterator iterPicYuvRec  = m_acListPicYuvRec[layer].begin();
+
+    Int iSize = Int( m_acListPicYuvRec[layer].size() );
+
+    for ( Int i = 0; i < iSize; i++ )
+    {
+      TComPicYuv*  pcPicYuvRec  = *(iterPicYuvRec++);
+      pcPicYuvRec->destroy();
+      delete pcPicYuvRec; pcPicYuvRec = NULL;
+    }
+  }  
+}
+
+Void TAppEncTop::xWriteRecon(UInt layer, Int iNumEncoded)
+{
+  Int i;
+
+  TComList<TComPicYuv*>::iterator iterPicYuvRec = m_acListPicYuvRec[layer].end();
+
+  for ( i = 0; i < iNumEncoded; i++ )
+  {
+    --iterPicYuvRec;
+  }
+
+  for ( i = 0; i < iNumEncoded; i++ )
+  {
+    TComPicYuv*  pcPicYuvRec  = *(iterPicYuvRec++);
+    if (!m_acLayerCfg[layer].getReconFile().empty())
+    {
+      m_acTVideoIOYuvReconFile[layer].write( pcPicYuvRec, m_acLayerCfg[layer].getConfLeft(), m_acLayerCfg[layer].getConfRight(), 
+        m_acLayerCfg[layer].getConfTop(), m_acLayerCfg[layer].getConfBottom() );
+    }
+  }
+}
+
+Void TAppEncTop::xWriteStream(std::ostream& bitstreamFile, Int iNumEncoded, const std::list<AccessUnit>& accessUnits)
+{
+  Int i;
+
+  list<AccessUnit>::const_iterator iterBitstream = accessUnits.begin();
+
+  for ( i = 0; i < iNumEncoded; i++ )
+  {
+    const AccessUnit& au = *(iterBitstream++);
+    const vector<UInt>& stats = writeAnnexB(bitstreamFile, au);
+    rateStatsAccum(au, stats);
+  }
+}
+
+#else // SVC_EXTENSION
 Void TAppEncTop::xGetBuffer( TComPicYuv*& rpcPicYuvRec)
 {
   assert( m_iGOPSize > 0 );
-  
+
   // org. buffer
   if ( m_cListPicYuvRec.size() == (UInt)m_iGOPSize )
@@ -479,5 +1095,5 @@
   {
     rpcPicYuvRec = new TComPicYuv;
-    
+
     rpcPicYuvRec->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
 
@@ -489,7 +1105,7 @@
 {
   TComList<TComPicYuv*>::iterator iterPicYuvRec  = m_cListPicYuvRec.begin();
-  
+
   Int iSize = Int( m_cListPicYuvRec.size() );
-  
+
   for ( Int i = 0; i < iSize; i++ )
   {
@@ -498,21 +1114,21 @@
     delete pcPicYuvRec; pcPicYuvRec = NULL;
   }
-  
+
 }
 
 /** \param iNumEncoded  number of encoded frames
- */
+*/
 Void TAppEncTop::xWriteOutput(std::ostream& bitstreamFile, Int iNumEncoded, const std::list<AccessUnit>& accessUnits)
 {
   Int i;
-  
+
   TComList<TComPicYuv*>::iterator iterPicYuvRec = m_cListPicYuvRec.end();
   list<AccessUnit>::const_iterator iterBitstream = accessUnits.begin();
-  
+
   for ( i = 0; i < iNumEncoded; i++ )
   {
     --iterPicYuvRec;
   }
-  
+
   for ( i = 0; i < iNumEncoded; i++ )
   {
@@ -528,8 +1144,9 @@
   }
 }
+#endif
 
 /**
- *
- */
+*
+*/
 void TAppEncTop::rateStatsAccum(const AccessUnit& au, const std::vector<UInt>& annexBsizes)
 {
@@ -572,5 +1189,9 @@
 void TAppEncTop::printRateSummary()
 {
+#if SVC_EXTENSION
+  Double time = (Double) m_iFrameRcvd / m_acLayerCfg[m_numLayers-1].getFrameRate();
+#else
   Double time = (Double) m_iFrameRcvd / m_iFrameRate;
+#endif
   printf("Bytes written to file: %u (%.3f kbps)\n", m_totalBytes, 0.008 * m_totalBytes / time);
 #if VERBOSE_RATE
Index: branches/HM-10.0-dev-SHM/source/App/TAppEncoder/TAppEncTop.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/App/TAppEncoder/TAppEncTop.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/App/TAppEncoder/TAppEncTop.h	(revision 54)
@@ -59,4 +59,12 @@
 private:
   // class interface
+#if SVC_EXTENSION
+  TEncTop                    m_acTEncTop [MAX_LAYERS];                    ///< encoder class
+  TEncTop*                   m_apcTEncTop [MAX_LAYERS];                   ///< encoder pointer class
+  TVideoIOYuv                m_acTVideoIOYuvInputFile [MAX_LAYERS];       ///< input YUV file
+  TVideoIOYuv                m_acTVideoIOYuvReconFile [MAX_LAYERS];       ///< output reconstruction file
+
+  TComList<TComPicYuv*>      m_acListPicYuvRec [MAX_LAYERS];              ///< list of reconstruction YUV files
+#else
   TEncTop                    m_cTEncTop;                    ///< encoder class
   TVideoIOYuv                m_cTVideoIOYuvInputFile;       ///< input YUV file
@@ -64,4 +72,5 @@
   
   TComList<TComPicYuv*>      m_cListPicYuvRec;              ///< list of reconstruction YUV files
+#endif
   
   Int                        m_iFrameRcvd;                  ///< number of received frames
@@ -77,5 +86,9 @@
   
   /// obtain required buffers
+#if SVC_EXTENSION
+  Void xGetBuffer(TComPicYuv*& rpcPicYuvRec, UInt layer);
+#else
   Void xGetBuffer(TComPicYuv*& rpcPicYuvRec);
+#endif
   
   /// delete allocated buffers
@@ -83,5 +96,11 @@
   
   // file I/O
+#if SVC_EXTENSION
+  Void xWriteRecon(UInt layer, Int iNumEncoded);
+  Void xWriteStream(std::ostream& bitstreamFile, Int iNumEncoded, const std::list<AccessUnit>& accessUnits);
+  Void printOutSummary();
+#else
   Void xWriteOutput(std::ostream& bitstreamFile, Int iNumEncoded, const std::list<AccessUnit>& accessUnits); ///< write bitstream to file
+#endif
   void rateStatsAccum(const AccessUnit& au, const std::vector<UInt>& stats);
   void printRateSummary();
@@ -92,5 +111,9 @@
   
   Void        encode      ();                               ///< main encoding function
+#if SVC_EXTENSION
+  TEncTop&    getTEncTop  (UInt layer)   { return  m_acTEncTop[layer]; }      ///< return encoder class pointer reference
+#else
   TEncTop&    getTEncTop  ()   { return  m_cTEncTop; }      ///< return encoder class pointer reference
+#endif
 };// END CLASS DEFINITION TAppEncTop
 
Index: branches/HM-10.0-dev-SHM/source/App/TAppEncoder/encmain.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/App/TAppEncoder/encmain.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/App/TAppEncoder/encmain.cpp	(revision 54)
@@ -57,5 +57,5 @@
   // print information
   fprintf( stdout, "\n" );
-  fprintf( stdout, "HM software: Encoder Version [%s]", NV_VERSION );
+  fprintf( stdout, "SHM software: Encoder Version [%s]", NV_VERSION );
   fprintf( stdout, NVM_ONOS );
   fprintf( stdout, NVM_COMPILEDBY );
Index: branches/HM-10.0-dev-SHM/source/Lib/TAppCommon/program_options_lite.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TAppCommon/program_options_lite.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TAppCommon/program_options_lite.h	(revision 54)
@@ -209,5 +209,57 @@
         return *this;
       }
-      
+#if 1 //SVC_EXTENSION
+      template<typename T>
+      OptionSpecific&
+        operator()(const std::string& name, T* storage, T default_val, unsigned uiMaxNum, const std::string& desc = "" )
+      {
+        std::string cNameBuffer;
+        std::string cDescriptionBuffer;
+
+        cNameBuffer       .resize( name.size() + 10 );
+        cDescriptionBuffer.resize( desc.size() + 10 );
+
+        for ( unsigned int uiK = 0; uiK < uiMaxNum; uiK++ )
+        {
+          // isn't there are sprintf function for string??
+          sprintf((char*) cNameBuffer.c_str()       ,name.c_str(),uiK,uiK);
+          sprintf((char*) cDescriptionBuffer.c_str(),desc.c_str(),uiK,uiK);
+
+          size_t pos = cNameBuffer.find_first_of('\0');
+          if(pos != std::string::npos)
+            cNameBuffer.resize(pos);
+      
+          parent.addOption(new Option<T>( cNameBuffer, (storage[uiK]), default_val, cDescriptionBuffer ));
+        }
+
+        return *this;
+      }
+
+      template<typename T>
+      OptionSpecific&
+        operator()(const std::string& name, T** storage, T default_val, unsigned uiMaxNum, const std::string& desc = "" )
+      {
+        std::string cNameBuffer;
+        std::string cDescriptionBuffer;
+
+        cNameBuffer       .resize( name.size() + 10 );
+        cDescriptionBuffer.resize( desc.size() + 10 );
+
+        for ( unsigned int uiK = 0; uiK < uiMaxNum; uiK++ )
+        {
+          // isn't there are sprintf function for string??
+          sprintf((char*) cNameBuffer.c_str()       ,name.c_str(),uiK,uiK);
+          sprintf((char*) cDescriptionBuffer.c_str(),desc.c_str(),uiK,uiK);
+
+          size_t pos = cNameBuffer.find_first_of('\0');
+          if(pos != std::string::npos)
+            cNameBuffer.resize(pos);
+
+          parent.addOption(new Option<T>( cNameBuffer, *(storage[uiK]), default_val, cDescriptionBuffer ));
+        }
+
+        return *this;
+      }
+#endif
       /**
        * Add option described by name to the parent Options list,
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/CommonDef.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/CommonDef.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/CommonDef.h	(revision 54)
@@ -56,5 +56,5 @@
 // ====================================================================================================================
 
-#define NV_VERSION        "10.0"                 ///< Current software version
+#define NV_VERSION        "1.2"                 ///< Current software version
 
 // ====================================================================================================================
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/ContextTables.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/ContextTables.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/ContextTables.h	(revision 54)
@@ -92,4 +92,7 @@
 #define NUM_SAO_MERGE_FLAG_CTX        1       ///< number of context models for SAO merge flags
 #define NUM_SAO_TYPE_IDX_CTX          1       ///< number of context models for SAO type index
+#if INTRA_BL
+#define NUM_INTRA_BL_PRED_CTX         3
+#endif
 
 #define NUM_TRANSFORMSKIP_FLAG_CTX    1       ///< number of context models for transform skipping 
@@ -327,4 +330,13 @@
 };
 
+#if INTRA_BL
+static const UChar 
+INIT_INTRA_BL_PRED_FLAG[3][NUM_INTRA_BL_PRED_CTX] = 
+{
+  { 185,  185,  201, }, 
+  { 197,  197,  185, }, 
+  { 197,  197,  185, }, 
+};
+#endif
 static const UChar
 INIT_TRANSFORMSKIP_FLAG[3][2*NUM_TRANSFORMSKIP_FLAG_CTX] = 
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/NAL.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/NAL.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/NAL.h	(revision 54)
@@ -47,4 +47,7 @@
   NalUnitType m_nalUnitType; ///< nal_unit_type
   UInt        m_temporalId;  ///< temporal_id
+#if SVC_EXTENSION
+  UInt        m_layerId;   ///< layer id
+#endif
   UInt        m_reservedZero6Bits; ///< reserved_zero_6bits
 
@@ -53,7 +56,13 @@
     NalUnitType nalUnitType,
     Int         temporalId = 0,
+#if SVC_EXTENSION
+    UInt        layerId = 0,
+#endif
     Int         reservedZero6Bits = 0)
     :m_nalUnitType (nalUnitType)
     ,m_temporalId  (temporalId)
+#if SVC_EXTENSION
+    ,m_layerId   (layerId)
+#endif
     ,m_reservedZero6Bits(reservedZero6Bits)
   {}
